
// DlgProxy.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "TestSdkQS.h"
#include "DlgProxy.h"
#include "TestSdkQSDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CTestSdkQSDlgAutoProxy

IMPLEMENT_DYNCREATE(CTestSdkQSDlgAutoProxy, CCmdTarget)

CTestSdkQSDlgAutoProxy::CTestSdkQSDlgAutoProxy()
{
	EnableAutomation();

	// To keep the application running as long as an automation
	//	object is active, the constructor calls AfxOleLockApp.
	AfxOleLockApp();

	// Get access to the dialog through the application's
	//  main window pointer.  Set the proxy's internal pointer
	//  to point to the dialog, and set the dialog's back pointer to
	//  this proxy.
	ASSERT_VALID(AfxGetApp()->m_pMainWnd);
	if (AfxGetApp()->m_pMainWnd)
	{
		ASSERT_KINDOF(CTestSdkQSDlg, AfxGetApp()->m_pMainWnd);
		if (AfxGetApp()->m_pMainWnd->IsKindOf(RUNTIME_CLASS(CTestSdkQSDlg)))
		{
			m_pDialog = reinterpret_cast<CTestSdkQSDlg*>(AfxGetApp()->m_pMainWnd);
			m_pDialog->m_pAutoProxy = this;
		}
	}
}

CTestSdkQSDlgAutoProxy::~CTestSdkQSDlgAutoProxy()
{
	// To terminate the application when all objects created with
	// 	with automation, the destructor calls AfxOleUnlockApp.
	//  Among other things, this will destroy the main dialog
	if (m_pDialog != nullptr)
		m_pDialog->m_pAutoProxy = nullptr;
	AfxOleUnlockApp();
}

void CTestSdkQSDlgAutoProxy::OnFinalRelease()
{
	// When the last reference for an automation object is released
	// OnFinalRelease is called.  The base class will automatically
	// deletes the object.  Add additional cleanup required for your
	// object before calling the base class.

	CCmdTarget::OnFinalRelease();
}

BEGIN_MESSAGE_MAP(CTestSdkQSDlgAutoProxy, CCmdTarget)
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CTestSdkQSDlgAutoProxy, CCmdTarget)
END_DISPATCH_MAP()

// Note: we add support for IID_ITestSdkQS to support typesafe binding
//  from VBA.  This IID must match the GUID that is attached to the
//  dispinterface in the .IDL file.

// {8da6854d-8c7c-425f-a939-207e64a74ef1}
static const IID IID_ITestSdkQS =
{0x8da6854d,0x8c7c,0x425f,{0xa9,0x39,0x20,0x7e,0x64,0xa7,0x4e,0xf1}};

BEGIN_INTERFACE_MAP(CTestSdkQSDlgAutoProxy, CCmdTarget)
	INTERFACE_PART(CTestSdkQSDlgAutoProxy, IID_ITestSdkQS, Dispatch)
END_INTERFACE_MAP()

// The IMPLEMENT_OLECREATE2 macro is defined in pch.h of this project
// {e6833695-9408-45c5-a8ff-f4bc6373fba9}
IMPLEMENT_OLECREATE2(CTestSdkQSDlgAutoProxy, "TestSdkQS.Application", 0xe6833695,0x9408,0x45c5,0xa8,0xff,0xf4,0xbc,0x63,0x73,0xfb,0xa9)


// CTestSdkQSDlgAutoProxy message handlers
